#include <stdio.h>
#include <sys/types.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include <freertos/semphr.h>
#include "freertos/event_groups.h"
#include "esp_system.h"
#include "esp_wifi.h"
#include "esp_event.h"
#include "esp_log.h"
#include "esp_event_loop.h"
#include "nvs_flash.h"
#include "driver/gpio.h"
#include "driver/rtc_io.h"
#include "tcpip_adapter.h"
#include "sdkconfig.h"
#include "lwip/udp.h"
#include <lwip/sockets.h>
#include <string.h>
#include <errno.h>
#include "esp_task_wdt.h"
#include "esp_int_wdt.h"
#include "esp_err.h"
#include "stdlib.h"
#include "esp_system.h"

#include "nvs_flash.h"
#include "nvs.h"
#include <esp_intr.h>
#include <soc/dport_reg.h>
#include <soc/gpio_sig_map.h>
#include <soc/rmt_struct.h>
#include "esp_smartconfig.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"


#include <stdio.h>
#include "math.h"
#include "esp_types.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/queue.h"
#include "soc/timer_group_struct.h"
#include "driver/periph_ctrl.h"
#include "driver/timer.h"
#include "driver/gpio.h"
#include "driver/adc.h"
#include <string.h>
#include <stdlib.h>
#include "sdkconfig.h"
#include "esp_err.h"
#include "esp_log.h"

#include "esp_system.h"
#include "esp_event.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/queue.h"
#include "driver/gpio.h"
#include "driver/adc.h"
#include "sine.h"



// UDP SOCKET

#define UDP_IP_DEFAULT 		"239.7.7.7"
#define UDP_PORT_DANCETRACK_1 50794
int sock_UDP_dance;

static char* TAG ="PRUEBA";

void Rx_Dancetrack_Task(void* arg);


static esp_err_t WIFIEventHandler(void *ctx, system_event_t *event){

    switch(event->event_id) {

    case SYSTEM_EVENT_STA_START:
    	ESP_LOGI(TAG, "SYSTEM_EVENT_STA_START");
    	break;

	case SYSTEM_EVENT_STA_CONNECTED:
		ESP_LOGI(TAG, "SYSTEM_EVENT_STA_CONNECTED");
		break;
    case SYSTEM_EVENT_STA_GOT_IP:
    	ESP_LOGI(TAG, "SYSTEM_EVENT_STA_GOT_IP: %s\n", ip4addr_ntoa(&event->event_info.got_ip.ip_info));

    	// TASK RX UDP
    	xTaskCreate(&Rx_Dancetrack_Task, "Rx_Dancetrack_Task", 1024*2, NULL, 2, NULL);
        break;
    case SYSTEM_EVENT_STA_STOP:
    	ESP_LOGI(TAG, "SYSTEM_EVENT_STA_STOP");
    	break;

    case SYSTEM_EVENT_STA_DISCONNECTED:
    	ESP_LOGI(TAG, "SYSTEM_EVENT_STA_DISCONNECTED");
    	break;

    case SYSTEM_EVENT_AP_START:
    	ESP_LOGI(TAG, "SYSTEM_EVENT_AP_START");
    	break;

    default:
        break;

    }
    return ESP_OK;
}

void InitWIFI(){

	// INITIALIZE THE TCPIP ADAPTER AND SETUD THE WIFI MODULE

	ESP_LOGI(TAG, "WIFI INITIALIZATION...");

	tcpip_adapter_init();

	ESP_ERROR_CHECK(esp_event_loop_init(WIFIEventHandler, NULL));

	wifi_init_config_t cfg = WIFI_INIT_CONFIG_DEFAULT();

	ESP_ERROR_CHECK(esp_wifi_init(&cfg));

	ESP_ERROR_CHECK( esp_wifi_set_storage(WIFI_STORAGE_RAM) );

	ESP_ERROR_CHECK(esp_wifi_set_mode(WIFI_MODE_STA));

	wifi_sta_config_t  wifi_sta_acquired_config=
	{

			"LAB",      /**< SSID of target AP*/
			"Laboratorio9",  /**< password of target AP*/
			0,        /**< whether set MAC address of target AP or not. Generally, station_config.bssid_set needs to be 0; and it needs to be 1 only when users need to check the MAC address of the AP.*/
			"",     /**< MAC address of target AP*/
			0       /**< channel of target AP. Set to 1~13 to scan starting from the specified channel before connecting to AP. If the channel of AP is unknown, set it to 0.*/
	};

	ESP_ERROR_CHECK( esp_wifi_set_config(WIFI_IF_STA, &wifi_sta_acquired_config) );

	//GO TO SYSTEM_EVENT_STA_START: STATE_TRYING_PRIMARY_NETWORK IN WIFIEventHandler

	ESP_ERROR_CHECK(esp_wifi_start());
	ESP_ERROR_CHECK(esp_wifi_connect());
}

void Rx_Dancetrack_Task(void* arg){

	// DECLARE MULTICAST
	struct ip_mreq mc_req;
	struct sockaddr_in multicastAddress;

	// CREATE A UDP SOCKET
	sock_UDP_dance = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	if (sock_UDP_dance < 0) {
		close(sock_UDP_dance);
		ESP_LOGI(TAG, "CREATE UDP DANCE SOCKET STATUS: %s", strerror(errno));
		vTaskDelete(NULL);
	}

	memset(&multicastAddress, 0, sizeof(multicastAddress));
	multicastAddress.sin_family      = AF_INET;
	multicastAddress.sin_addr.s_addr = htonl(INADDR_ANY);
	multicastAddress.sin_port = htons(UDP_PORT_DANCETRACK_1);


	// BIND SOCKET TO MULTICAST ADDRESS
	int rc  = bind(sock_UDP_dance, (struct sockaddr *)&multicastAddress, sizeof(multicastAddress));
	if (rc < 0) {
		close(sock_UDP_dance);
		ESP_LOGI(TAG, "BIND UDP DANCE SOCKET STATUS: %s", strerror(errno));
		vTaskDelete(NULL);
	}

	mc_req.imr_multiaddr.s_addr = inet_addr(UDP_IP_DEFAULT);
	mc_req.imr_interface.s_addr = htonl(INADDR_ANY);

	// JOIN MULTICAST ADDRESS PARTY
	if ((setsockopt(sock_UDP_dance, IPPROTO_IP, IP_ADD_MEMBERSHIP, (void*) &mc_req, sizeof(mc_req))) < 0){
		close(sock_UDP_dance);
		vTaskDelete(NULL);
	}

	char bass1, bass2;

	ESP_LOGI(TAG, "RECEIVING DANCETRACK...");
	while(1){

		// DECLARE SERVER ADDRESS
		struct sockaddr_in serverAddress;

		// SET A BUFFER TO RECEIVE MULTICAST MESSAGE
		int sizeBuffer = 100;
		char* buffer = calloc(sizeBuffer, sizeof(char));

		unsigned int addresLentgh =sizeof(serverAddress);
		memset(&serverAddress, 0, addresLentgh);

		// RECEIVE MESSAGE
		int recvSock = recvfrom(sock_UDP_dance, buffer, sizeBuffer, MSG_MORE, (struct sockaddr *)&serverAddress, &addresLentgh);
		ESP_LOGI(TAG, "RECEIVE STATUS: %s : %s.",strerror(errno), buffer);
		  if (recvSock > 0) { // IF RECEIVED MESSAGE IT´S SUCCESS...

				// SEGMENTATION OF RECEIVED MESSAGE, TOKEN IS SPACE

			  bass1 = atoi(strtok (buffer," "));
			  bass2 = atoi(strtok (NULL," "));

		  }
	}
}


/**
 * @brief In this test, we will test hardware timer0 and timer1 of timer group0.
 */
void app_main()
{


	InitWIFI(); // HAVE TO ENTRY SSID AND PASSWORD

	//WHEN ESP GET IP ADDRESS IT INITIALIZE UDP RX


}





